/*****************************************************************************
* Sistemas Integrados TECNISA                                                *
*                                                                            *
* Compras e Suprimentos                                                      *
*                                                                            *
******************************************************************************
*                                                                            *
* Nome: CALC_PROX_ENTR_MES                                                   *
*                                                                            *
* Descrio:                                                                 *
* Calcula proximas datas de entrega para um determinado mes/semana           *
*                                                                            *
*                                                                            *
* Criao:                                                                   *
* 03/01/2000 - Yoris L. de Souza                                             *
*                                                                            *
* Manutenes:                                                               *
*   /  /   -                                                                 *
*                                                                            *
*                                                                            *
******************************************************************************
* @H:\SISTEMAS\DBA\SQL\ORACLE\8020_CMPSTP_CALC_PROX_ENTR_MES.SQL
******************************************************************************
* PARAMETROS:                                                                *
*                                                                            *
* P_CDFILIAL     - Cdigo da Filial                                          *
* P_CDPERIENTR   - Cdigo da Periodicidade de Entrega                        *
* P_DTINICIAL    - Data do Inicio do Mes                                     *
* P_NRMESES      - Numero de meses a serem calculados                        *
******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'CALC_PROX_ENTR_MES'  and
            type = 'P'                  and
            u.uid = o.uid               and
            u.name = USER)
  DROP PROCEDURE CALC_PROX_ENTR_MES
  GO

CREATE PROCEDURE CALC_PROX_ENTR_MES
  @P_CDFILIAL     VARCHAR(4),
  @P_CDPERIENTR   VARCHAR(2),
  @P_DTINICIAL    DATETIME,
  @P_DTINIAUX     DATETIME OUTPUT
AS
  DECLARE @V_IDTIPODIA  VARCHAR(1);
  DECLARE @V_IDDIANUTIL VARCHAR(1);
  DECLARE @V_DTINIAUX   DATETIME;
  DECLARE @V_DTULTDAT   DATETIME;

BEGIN
  SELECT @V_IDTIPODIA = IDTIPODIA,
         @V_IDDIANUTIL = IDDIANUTIL
  FROM PERIENTR
  WHERE
  CDPERIENTR = @P_CDPERIENTR;

  SET @V_DTULTDAT = @P_DTINICIAL;
  EXEC ULTIMO_DIA_MES @P_DTDATA = @V_DTULTDAT OUTPUT;

  IF (@V_IDTIPODIA = 'M')
  BEGIN
     EXEC MENSAL_PROX_DATA_ENTREGA @P_CDFILIAL,@P_CDPERIENTR,@V_DTULTDAT,@V_IDDIANUTIL,@P_DTDIAENTR = @P_DTINIAUX OUTPUT;
  END
  ELSE
  BEGIN
     IF (@V_IDTIPODIA = 'S') BEGIN
        EXEC SEMANAL_PROX_DATA_ENTREGA @P_CDFILIAL,@P_CDPERIENTR,@V_DTULTDAT,@V_IDDIANUTIL,@P_DTENTRAUX = @P_DTINIAUX OUTPUT;
     END;
  END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'CALC_PROX_ENTR_MES','4.11.151';
GO
