<?php
namespace Teknisa\Model\Gestaopessoas\Repositories;

use HCM\Util\DateUtil;
use HCM\Util\Repositories;
use HCM\Util\FPA;

class GpeMovimentacao extends \Doctrine\ORM\EntityRepository {

    public function retornaMovimentacaoAnterior($mesCompetencia, $nrOrg, $nrVinculo, $dtMovimentacao, $cdCagedAdmissao, $nrtipoestrutlegal){
	
	$params = array('dtmescompetenc'=>$mesCompetencia, 'nrorg'=>$nrOrg, 'nrvinculom'=>$nrVinculo, 'dtmovimentacao'=>$dtMovimentacao,
	 'cdcagedadmissao'=>$cdCagedAdmissao, 'nrtipoestrutlegal'=>$nrtipoestrutlegal);

    $gpe_Movimentacao =  '\Teknisa\Model\Gestaopessoas\Entities\GpeMovimentacao';
    $gpe_Tpmovtransfm =  '\Teknisa\Model\Gestaopessoas\Entities\GpeTpmovtransfm';
    $gpe_Tpmovtransfh =  '\Teknisa\Model\Gestaopessoas\Entities\GpeTpmovtransfh';

$sql = <<<SQL
SELECT s FROM $gpe_Movimentacao s
WHERE s.nrorg = :nrorg
AND s.nrvinculom = :nrvinculom
AND s.nrtipoestrutura = :nrtipoestrutlegal
AND s.dtinimoviment = (SELECT MAX(ss.dtinimoviment)
                     FROM $gpe_Movimentacao ss
                     INNER JOIN $gpe_Tpmovtransfm f
                      WITH ss.nrtpmovtransfm = f.nrtpmovtransfm
                     INNER JOIN $gpe_Tpmovtransfh fh
                      WITH f.nrtpmovtransfm = fh.nrtpmovtransfm
                     WHERE ss.nrorg = :nrorg
                     AND ss.nrvinculom = :nrvinculom
                     AND ss.dtinimoviment < :dtmovimentacao
                     AND ss.nrtipoestrutura = :nrtipoestrutlegal
                     AND fh.codcaged IN (:cdcagedadmissao)
                     AND fh.dtmescompetenc IN (SELECT MAX(mfh.dtmescompetenc)
                                                             FROM $gpe_Tpmovtransfh mfh
                                                             WHERE mfh.nrtpmovtransfm = f.nrtpmovtransfm
                                                                             AND mfh.dtmescompetenc <= :dtmescompetenc))
SQL;
        $result = $this->getEntityManager()->createQuery($sql)->execute($params);
        if(!empty($result))
        	return $result[0];
        else 
        	return $result;
    }
    
    public function retornaMovimentacaoRecentePorEstrutura(
        $nrorg, $nrtipoestrutlegal, $nrVinculo, $mesCompetencia
    ){  
        
        $dtUltDiaMes = DateUtil::getUltimoDiaDoMes(DateUtil::getDataDeString($mesCompetencia))->format('d/m/Y');
        $dtRecente = DateUtil::adicionaIntervalo(DateUtil::getDataDeString($mesCompetencia),1,'M')->format('d/m/Y');
    	$params = array(
    	    'nrorg' => $nrorg, 
	        'nrtipoestrutlegal' => $nrtipoestrutlegal, 
    	    'nrvinculom' => $nrVinculo, 
	        'dtRecente' => $dtRecente,
	        'dtultdiames' => $dtUltDiaMes
	    );
        
        $estruturam =  '\Teknisa\Model\Gestaopessoas\Entities\GpeMovimentacao';
        $gpe_Movimentacao =  '\Teknisa\Model\Gestaopessoas\Entities\GpeMovimentacao';
    
$sql = <<<SQL
        SELECT m FROM $gpe_Movimentacao m
        WHERE m.nrorg = :nrorg
        AND m.nrvinculom = :nrvinculom
		AND m.dtinimoviment < :dtRecente
		AND m.nrtipoestrutura = :nrtipoestrutlegal
        AND m.nrestruturam IN (
                                SELECT e.nrestruturam
                                FROM $estruturam e
                                WHERE e.nrorg = :nrorg
								  AND e.nrtipoestrutura = :nrtipoestrutlegal
                              )
        AND (m.dtfimmoviment >= :dtultdiames OR m.dtfimmoviment IS NULL)
        ORDER BY m.dtinimoviment DESC
SQL;

        $result = $this->getEntityManager()->createQuery($sql)->execute($params);
    
    	return $result;
    }
    
    public  function getMovimentacoesTransferencia($nrorg,$dtcompetencia, $nrvinculom, $tipoestrutura, $nrestruturam = null, $dtinicial = null, $dtfinal = null) {

        $dtultidiacomp = DateUtil::getUltimoDiaDoMes($dtcompetencia);
        $params = array(
            ':p_nrorg'           => $nrorg,
            ':p_nrvinculom'      => $nrvinculom,
            ':p_nrtipoestrutura' => $tipoestrutura,
            ':p_nrestruturam'    => $nrestruturam,
            ':p_dtinicial'       => (is_null($dtinicial) ? $dtcompetencia : $dtinicial),
            ':p_dtfinal'         => (is_null($dtfinal) ? $dtultidiacomp : $dtfinal)
        );
            
         $gpe_movimentacao = Repositories::GPE_MOVIMENTACAO;    
        
        $sql = <<<SQL
select mv
  from $gpe_movimentacao mv
 where mv.nrorg           = :p_nrorg
   and mv.nrvinculom      = :p_nrvinculom
   and mv.nrtipoestrutura = :p_nrtipoestrutura
   and (mv.nrestruturam = :p_nrestruturam or :p_nrestruturam is null)
   and mv.nrtpmovtransfm  in (8,9)
   and mv.dtinimoviment between :p_dtinicial and :p_dtfinal
 order by mv.dtinimoviment
SQL;
        $result = $this->getEntityManager()->createQuery($sql)->execute($params);
        return $result;
    }
    
    public function getMovimentacaoTransfEntrada($nrorg, $nrvinculom, $tipoestrutura,$dtcompetencia, $nrestruturam = null, $dtinicial = null, $dtfinal = null) {
        $gpe_movimentacao = Repositories::GPE_MOVIMENTACAO;
        $dtultidiacomp = DateUtil::getUltimoDiaDoMes($dtcompetencia);
        $params = array(
            'p_nrorg'           => $nrorg,
            'p_nrvinculom'      => $nrvinculom,
            'p_nrtipoestrutura' => $tipoestrutura,
            'p_nrestruturam'    => $nrestruturam,
            'p_dtinicial'       => (is_null($dtinicial) ? $dtcompetencia : $dtinicial),
            'p_dtfinal'         => (is_null($dtfinal) ? $dtultidiacomp : $dtfinal)
        );

        $sql = <<<SQL
select me
  from $gpe_movimentacao me
 where me.nrorg           = :p_nrorg
   and me.nrvinculom      = :p_nrvinculom
   and me.nrtipoestrutura = :p_nrtipoestrutura
   and (me.nrestruturam = :p_nrestruturam or :p_nrestruturam is null)
   and me.nrtpmovtransfm = 8
   and me.dtinimoviment between :p_dtinicial and :p_dtfinal
   and exists (select 1
                 from $gpe_movimentacao ms
                where ms.nrorg           = me.nrorg
                  and ms.nrvinculom      = me.nrvinculom
                  and ms.nrtipoestrutura = me.nrtipoestrutura
                  and ms.nrestruturam   <> me.nrestruturam
                  and ms.nrtpmovtransfm  = 9
                  and ms.dtinimoviment  <= me.dtinimoviment)
SQL;
        $result = $this->getEntityManager()->createQuery($sql)->execute($params);
        return $result;
    }

    public function getMovimentacaoTransfSaida($nrorg, $nrvinculom, $tipoestrutura, $dtcompetencia, $nrestruturam = null, $dtinicial = null, $dtfinal = null) {
        $gpe_movimentacao = Repositories::GPE_MOVIMENTACAO;
        $dtultidiacomp = DateUtil::getUltimoDiaDoMes($dtcompetencia);
        $params = array(
            'p_nrorg'           => $nrorg,
            'p_nrvinculom'      => $nrvinculom,
            'p_nrtipoestrutura' => $tipoestrutura,
            'p_nrestruturam'    => $nrestruturam,
            'p_dtinicial'       => (is_null($dtinicial) ? $dtcompetencia : $dtinicial),
            'p_dtfinal'         => (is_null($dtfinal) ? $dtultidiacomp : $dtfinal)
        );

        $sql = <<<SQL
select me
  from $gpe_movimentacao me
 where me.nrorg           = :p_nrorg
   and me.nrvinculom      = :p_nrvinculom
   and me.nrtipoestrutura = :p_nrtipoestrutura
   and (me.nrestruturam = :p_nrestruturam or :p_nrestruturam is null)
   and me.nrtpmovtransfm  = 9
   and me.dtinimoviment between :p_dtinicial and :p_dtfinal
SQL;
        $result = $this->getEntityManager()->createQuery($sql)->execute($params);
        return $result;
    }

     public function getMovimentacoes($nrorg, $nrtipoestrutura, $nrvinculom) {
         
        $dtmescompetencia = FPA::getUltimoDiaMes();
        
        $params = array('dtmescompetenc'=>$dtmescompetencia, 'nrorg'=>$nrorg, 'nrvinculom'=>$nrvinculom,
	    'nrtipoestrutura'=> $nrtipoestrutura);
	    
        $gpe_Movimentacao =  '\Teknisa\Model\Gestaopessoas\Entities\GpeMovimentacao';
        
        $sql = <<<SQL
SELECT g FROM $gpe_Movimentacao g
            WHERE g.nrorg           = :nrorg
              AND g.nrtipoestrutura = :nrtipoestrutura
			  AND g.nrtipotransfer  = 1
              AND g.nrvinculom      = :nrvinculom
              AND g.dtinimoviment   = (SELECT MAX(gm.dtinimoviment)
                                      FROM $gpe_Movimentacao gm
                                     WHERE gm.nrorg           = :nrorg
                                       AND gm.nrtipoestrutura = :nrtipoestrutura
                                       AND gm.nrvinculom      = :nrvinculom
                                       AND gm.dtinimoviment  <= :dtmescompetenc)
              AND (g.dtfimmoviment IS NULL OR g.dtfimmoviment >= :dtmescompetenc)
SQL;
        
        $result = $this->getEntityManager()->createQuery($sql)->execute($params);
        
        return $result; 
    }
    
    public function getMovimentacao($nrorg, $nrtipoestrutura, $nrvinculom) {
        $dtmescompetencia = FPA::getUltimoDiaMes();
        
        $params = array('dtmescompetenc'=>$dtmescompetencia, 'nrorg'=>$nrorg, 'nrvinculom'=>$nrvinculom,
	    'nrtipoestrutura'=> $nrtipoestrutura);
	    
        $gpe_Movimentacao =  '\Teknisa\Model\Gestaopessoas\Entities\GpeMovimentacao';
        
        $sql = <<<SQL
SELECT g FROM $gpe_Movimentacao g
            WHERE g.nrorg           = :nrorg
              AND g.nrtipoestrutura = :nrtipoestrutura
              AND g.nrvinculom      = :nrvinculom
              AND g.dtinimoviment   = (SELECT MAX(gm.dtinimoviment)
                                      FROM $gpe_Movimentacao gm
                                     WHERE gm.nrorg           = :nrorg
                                       AND gm.nrtipoestrutura = :nrtipoestrutura
                                       AND gm.nrvinculom      = :nrvinculom
                                       AND gm.dtinimoviment  <= :dtmescompetenc)
SQL;

        $result = $this->getEntityManager()->createQuery($sql)->execute($params);
        return $result;
    }
    
    public function retornaMovimentacoesPorTipo($nrOrg, $nrVinculo, $tipo, $ultimoDiaCompetencia, $tipoestrutura){
        
        $params = array('nrtipotransfer'=> $tipo, 'dtmescompetenc'=> $ultimoDiaCompetencia, 'nrorg'=>$nrOrg, 'nrvinculom'=>$nrVinculo,
	    'nrtipoestrutura'=> $tipoestrutura);
	    
        $gpe_Movimentacao =  '\Teknisa\Model\Gestaopessoas\Entities\GpeMovimentacao';
        
        $sql = <<<SQL
SELECT g FROM $gpe_Movimentacao g
            WHERE g.nrorg           = :nrorg
              AND g.nrvinculom      = :nrvinculom
              AND g.nrtipotransfer      = :nrtipotransfer
              AND g.dtinimoviment   <= :dtmescompetenc
              AND g.dtfimmoviment   is null
              AND g.nrtipoestrutura = :nrtipoestrutura
              ORDER BY g.dtinimoviment DESC
SQL;

        $result = $this->getEntityManager()->createQuery($sql)->execute($params);
        return $result;
    }
    
    public function retornaMovimentacoesPorTipoEstrutura($nrOrg, $nrVinculo, $ultimoDiaCompetencia, $tipoestrutura){
        
        $params = array('dtmescompetenc'=> $ultimoDiaCompetencia, 'nrorg'=>$nrOrg, 'nrvinculom'=>$nrVinculo,
	    'nrtipoestrutura'=> $tipoestrutura);
	    
        $gpe_Movimentacao =  '\Teknisa\Model\Gestaopessoas\Entities\GpeMovimentacao';
        
        $sql = <<<SQL
SELECT g FROM $gpe_Movimentacao g
            WHERE g.nrorg           = :nrorg
              AND g.nrvinculom      = :nrvinculom
              AND g.dtinimoviment   <= :dtmescompetenc
              AND g.dtfimmoviment   is null
              AND g.nrtipoestrutura = :nrtipoestrutura
              ORDER BY g.dtinimoviment DESC
SQL;

        $result = $this->getEntityManager()->createQuery($sql)->execute($params);
        return $result;
    }
    
    public function retornaMovimentacaoRecentePorTipoEstrutura($nrOrg, $nrVinculo, $ultimoDiaCompetencia, $tipoestrutura){
        
        $params = array('dtmescompetenc'=> $ultimoDiaCompetencia, 'nrorg'=>$nrOrg, 'nrvinculom'=>$nrVinculo,
	    'nrtipoestrutura'=> $tipoestrutura);
	    
        $gpe_Movimentacao =  '\Teknisa\Model\Gestaopessoas\Entities\GpeMovimentacao';
        
        $sql = <<<SQL
SELECT g FROM $gpe_Movimentacao g
            WHERE g.nrorg           = :nrorg
              AND g.nrvinculom      = :nrvinculom
              AND g.dtinimoviment   = (SELECT MAX(gm.dtinimoviment)
                                      FROM $gpe_Movimentacao gm
                                     WHERE gm.nrorg           = :nrorg
                                       AND gm.nrtipoestrutura = :nrtipoestrutura
                                       AND gm.nrvinculom      = :nrvinculom
                                       AND gm.dtinimoviment  <= :dtmescompetenc)
              AND g.dtfimmoviment   is null
              AND g.nrtipoestrutura = :nrtipoestrutura
              ORDER BY g.dtinimoviment DESC
SQL;
        
        $result = $this->getEntityManager()->createQuery($sql)->execute($params);
        return $result;
    }
    
    /*Igual acima, porém com diferença na data de fim do movimento*/
    public function retornaMovimentacoesPorTipoHolerite($nrOrg, $nrVinculo, $tipo, $ultimoDiaCompetencia, $tipoestrutura){
        
        $params = array('nrtipotransfer'=> $tipo, 'dtmescompetenc'=> $ultimoDiaCompetencia, 'nrorg'=>$nrOrg, 'nrvinculom'=>$nrVinculo,
	    'nrtipoestrutura'=> $tipoestrutura);
	    
        $gpe_Movimentacao =  '\Teknisa\Model\Gestaopessoas\Entities\GpeMovimentacao';
        
        $sql = <<<SQL
SELECT g FROM $gpe_Movimentacao g
            WHERE g.nrorg           = :nrorg
              AND g.nrvinculom      = :nrvinculom
              AND g.nrtipotransfer      = :nrtipotransfer
              AND g.dtinimoviment   <= :dtmescompetenc
              AND ( g.dtfimmoviment is null OR g.dtfimmoviment >= :dtmescompetenc )
              AND g.nrtipoestrutura = :nrtipoestrutura
              ORDER BY g.dtinimoviment DESC
SQL;

        $result = $this->getEntityManager()->createQuery($sql)->execute($params);
        return $result;
    }
    
}